import es, playerlib, cfglib, gamethread

config = cfglib.AddonCFG(es.getAddonPath("alien") + "/alien.cfg")
config.text("**************************")
config.text("   Alien Invasion Options ")
config.text("**************************")
alien_health   = config.cvar("alien_health",   150, "Alien's Health")
alien_speed   = config.cvar("alien_speed",   1.5, "Aliens's Speed")
alien_max   = config.cvar("alien_max",   6, "Amount of t's")
fbi_health   = config.cvar("fbi_health",   100, "FBI Health")
fbi_speed   = config.cvar("fbi_speed",   1, "FBI Speed")
config.text("\n")
config.text("**************************")
config.text("          Regen           ")
config.text("**************************")
regen_time   = config.cvar("regen_time",   5, "How many seconds till the regen after been hurt")
regen_add   = config.cvar("regen_add",   5, "How often Is added on while regen")
regen_amount   = config.cvar("regen_amount",   5, "Amount goes up by")


config.write()

dict_players = {}

# ======================#
#               PUBLIC
# ======================#
info = es.AddonInfo()
info.name     = "Alien Invasion"
info.version  = "0.2"
info.url      = "None"
info.basename = "sic_alien"
info.author   = "sicman_adrian"
es.ServerVar('sic_alien', info.version, info.name).makepublic()

# ======================#
#  MODELS&MATERIALS
# ======================#
model_listfbi = ['.mdl', '.dx80.vtx', '.dx90.vtx', '.phy', '.sw.vtx', '.vvd', '.xbox.vtx']
material_listfbi = ['.vmt', '.vtf', '_glass.vmt']

model_dirfbi = 'models/player/ics/ct_gign_fbi'
material_dirfbi = 'materials/models/player/ics/ct_gign_fbi'

model_listpredator = ['.mdl', '.dx80.vtx', '.dx90.vtx', '.phy', '.sw.vtx', '.vvd', '.xbox.vtx', '_head.mdl', '_head.dx80.vtx', '_head.dx90.vtx', '_head.phy', '_head.sw.vtx', '_head.vvd', '_head.xbox.vtx', '_hs.mdl', '_hs.dx80.vtx', '_hs.dx90.vtx', '_hs.phy', '_hs.sw.vtx', '_hs.vvd', '_hs.xbox.vtx']
material_listpredator = ['predator_camouflaged/devices.vmt', 'predator_camouflaged/limbs.vmt', 'predator_camouflaged/torso.vmt','predator_decamouflaged/devices.vmt', 'predator_decamouflaged/devices.vtf', 'predator_decamouflaged/devices_norm.vtf', 'predator_decamouflaged/limbs.vmt', 'predator_decamouflaged/limbs.vtf', 'predator_decamouflaged/limbs_norm.vtf', 'predator_decamouflaged/torso.vmt', 'predator_decamouflaged/torso.vtf', 'predator_decamouflaged/torso_norm.vtf']


model_dirpredator = 'models/player/slow/predator_camouflaged'
material_dirpredator = 'materials/models/player/slow'

weapon_ammo_dict = {'weapon_m4a1':90,'weapon_ak47':90,'weapon_awp':30,'weapon_scout':90,'weapon_sg552':90, 'weapon_galil':90,'weapon_famas':90,'weapon_sg550':90,'weapon_aug':90,'weapon_m249':200,'weapon_g3sg1':90, 'weapon_ump45':100,'weapon_mp5navy':120,'weapon_m3':32,'weapon_xm1014':32,'weapon_tmp':120,'weapon_mac10':120, 'weapon_p90':100,'weapon_usp':100,'weapon_glock':100,'weapon_deagle':35,'weapon_p228':52,'weapon_elite':120,
'weapon_fiveseven':100}

def load():
    config.execute()
    downloads()
    es.doblock('corelib/noisy_on')

def unload():
    es.doblock('corelib/noisy_off')

def es_map_start(ev):
    downloads()

def downloads():
    for model in model_listfbi:
        es.stringtable('downloadables', model_dirfbi + model)
    for material in material_listfbi:
        es.stringtable('downloadables', material_dirfbi + material)
    for model in model_listpredator:
        es.stringtable('downloadables', model_dirpredator + model)
    for material in material_listpredator:
        es.stringtable('downloadables', material_dirpredator + material)

def player_connect(ev):
    userid = ev['userid']
    if userid not in dict_players:
        dict_players[userid] = {'kick':0}

def player_spawn(ev):
    userid = ev['userid']
    player = playerlib.getPlayer(userid)
    if ev['es_userteam'] == '2':
        player.set('model', 'models/player/slow/predator_camouflaged/predator_camouflaged.mdl')
        player.set('speed', alien_speed)
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', alien_health)
        es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
        es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
        es.server.queuecmd('es_fire %s player_weaponstrip kill'%userid)
        gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s weapon_knife'%userid)
        gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s item_nvgs'%userid)
    elif ev['es_userteam'] == '3':
          player.set('model', 'models/player/ics/ct_gign_fbi/ct_gign.mdl')
          player.set('speed', fbi_speed)
          es.setplayerprop(userid, 'CBasePlayer.m_iHealth', fbi_health)
          gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s item_nvgs'%userid)

def weapon_reload(event_var):
    userid = int(event_var['userid'])
    myPlayer = playerlib.getPlayer(userid)
    weapon = myPlayer.attributes['weapon']
    if weapon in weapon_ammo_dict:
        myPlayer.set('ammo',(weapon,weapon_ammo_dict[weapon]))

def item_pickup(ev):
    userid = ev['userid']
    myPlayer = playerlib.getPlayer(userid)
    weapon = myPlayer.attributes['weapon']
    if ev['es_userteam'] == '2':
        if ev['item'] != 'knife':
            es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
            es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
            es.server.queuecmd('es_fire %s player_weaponstrip kill'%userid)
            gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s weapon_knife'%userid)
            gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s item_nvgs'%userid)

def weapon_fire(ev):
    userid = ev['userid']
    myPlayer = playerlib.getPlayer(userid)
    weapon = myPlayer.attributes['weapon']
    if ev['es_userteam'] == '2':
        if ev['es_userweapon'] != 'weapon_knife':
            es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
            es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
            es.server.queuecmd('es_fire %s player_weaponstrip kill'%userid)
            gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s weapon_knife'%userid)
            gamethread.delayed(0, es.server.queuecmd, 'es_xgive %s item_nvgs'%userid)

def round_end(ev):
    teams()
    es.queryclientvar(userid, 'cl_radaralpha')
    es.queryclientvar(userid, 'r_shadows')


def teams():
    t = es.getplayercount('2')
    if t > alien_max:
        userid = random.choice(playerlib.getUseridList('#t'))
        es.changeteam(userid, '3')
        es.tell(userid, '#multi','#greenYou have been moved to ct')
        teams()


def es_player_variable(ev):
    userid = ev['userid']
    myPlayer = playerlib.getPlayer(userid)
    myteam = myPlayer.attributes['teamid']
    if ev['status'] == 'success':
        if ev['variable'] == 'cl_radaralpha':
            if int(ev['value']):
                es.changeteam(ev['userid'], 1)
                es.tell(ev['userid'], '#multi', '#greenYou must type #lightgreencl_radaralpha 0#green in your console if you want to play, If you don\'t you will be kicked!')
                dict_players[userid]['kick'] += 1
        if ev['variable'] == 'r_shadows':
            if int(ev['value']):
                es.changeteam(ev['userid'], 1)
                es.tell(ev['userid'], '#multi', '#greenYou must type #lightgreen r_shadows 0#green in your console if you want to play, If you don\'t you will be kicked!')
                dict_players[userid]['kick'] += 1

def player_team(ev):
    userid = ev['userid']
    es.queryclientvar(userid, 'cl_radaralpha')
    es.queryclientvar(userid, 'r_shadows')
    if dict_players[userid]['kick'] == 3:
        es.server.queuecmd('kickid %s' % userid)

def player_disconnect(ev):
    for delay in ['regen ']:
        gamethread.cancelDelayed(delay + ev['userid'])

def player_death(ev):
    gamethread.cancelDelayed('regen %s'%ev['userid'])

def player_hurt(ev):
    userid = ev['userid']
    if ev['es_userteam'] == '2':
        gamethread.cancelDelayed('regen %s'%userid) 
        gamethread.delayedname(regen_time, 'regen %s'%userid, regen, userid) 

def regen(userid):
    health = es.getplayerprop(userid, 'CBasePlayer.m_iHealth')
    if health+regen_amount <=  alien_health:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health+regen_amount)
        gamethread.delayedname(regen_add, 'regen %s'%userid, regen, userid)
    else:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', alien_health)